﻿;***qDoc*** 
;==========
;
;Open image document demo program.
;
;This opens the document created with the "Demo - CreateDocument.pb" demo and allows the user to view the images contained within.
;/////////////////////////////////////////////////////////////////////////////////


XIncludeFile "../../qDoc.pbi"

;GUI constants.
  #WindowWidth = 350
  #WindowHeight = 200

  #MainWindow = 0
  #ImageWindow = 1

  Enumeration
    #FrameGadget
    #ListIcon
    #ScrollArea
    #ImageGadget
  EndEnumeration


Define myDoc.qDoc_DocumentObject, myFile.qDoc_FileObject

;Open our disc-based compound document.
  myDoc = qDoc_OpenDocument("images.qDoc")

If myDoc
  If OpenWindow(#MainWindow, 0, 0, #WindowWidth, #WindowHeight, "qDoc image document", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    FrameGadget(#FrameGadget, 10, 10, #WindowWidth - 20, #WindowHeight - 20, "Double click image to view...")
    ListIconGadget(#ListIcon, 20, 40, #WindowWidth - 40, #WindowHeight - 60, "Image file", 150, #PB_ListIcon_FullRowSelect)
      AddGadgetColumn(#ListIcon, 1, "Size (bytes)", 150)
    ;Enumerate our document and add all image files found to the list icon.
      numFiles = myDoc\BeginFileList()
      For i = 0 To numFiles-1
        fileName$ = myDoc\GetFileListEntry(i)
        AddGadgetItem(#ListIcon, -1, fileName$ + #LF$ + Str(myDoc\GetFileSize(fileName$)))
      Next
      myDoc\FinishFileList()
    ;Open a window to display the selected image.
      OpenWindow(#ImageWindow, 0, 0, 400, 400, "qDoc image document", #PB_Window_TitleBar|#PB_Window_Invisible, WindowID(#MainWindow))
      ScrollAreaGadget(#ScrollArea, 10, 10, 380, 380, 1000, 1000, 30, #PB_ScrollArea_Flat|#PB_ScrollArea_Center)
        ImageGadget(#ImageGadget, 0, 0, 0, 0, 0)
      CloseGadgetList()

    Repeat
      eventID = WaitWindowEvent()
      Select eventID
        Case #PB_Event_Gadget
          Select EventGadget()
            Case #ListIcon
              If EventType() = #PB_EventType_LeftDoubleClick
                item = GetGadgetState(#ListIcon)
                If item >-1
                  If IsImage(1)
                    FreeImage(1)
                  EndIf
                  ;Open the appropriate document image file.
                    myFile = myDoc\ReadFile("image" + Str(item+1))
                    If myfile
                      numBytes = myFile\Lof()
                      If numBytes
                        buffer = AllocateMemory(numBytes)
                        If buffer
                          myFile\ReadData(buffer, numBytes)
                          If CatchImage(1, buffer, numBytes)
                            SetGadgetState(#ImageGadget, ImageID(1))
                            SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_InnerWidth, ImageWidth(1))
                            SetGadgetAttribute(#ScrollArea, #PB_ScrollArea_InnerHeight, ImageHeight(1))
                            HideWindow(#ImageWindow, 0)
                            SetActiveGadget(#Listicon)
                          EndIf
                          FreeMemory(buffer)                        
                        EndIf
                      EndIf
                      myfile\Close()                    
                    EndIf
                EndIf
              EndIf          
            
          EndSelect
      EndSelect
    Until eventID = #PB_Event_CloseWindow    
  EndIf
  myDoc\Close()
Else
  MessageRequester("qDoc!", "Could not open the 'images.qDoc' compound document! Check that it exists!")
EndIf


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 33
; FirstLine = 22
; EnableUnicode
; EnableXP
; Executable = nxReportU.dll